"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
exports.__esModule = true;
var React = require("react");
var PropTypes = require("prop-types");
var autosize = require("autosize");
var _getLineHeight = require("line-height");
var getLineHeight = _getLineHeight;
var RESIZED = "autosize:resized";
/**
 * A light replacement for built-in textarea component
 * which automaticaly adjusts its height to match the content
 */
var TextareaAutosizeInner = /** @class */ (function (_super) {
    __extends(TextareaAutosizeInner, _super);
    function TextareaAutosizeInner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            lineHeight: null
        };
        _this.onResize = function (e) {
            if (_this.props.onResize) {
                _this.props.onResize(e);
            }
        };
        _this.updateLineHeight = function () {
            var forwardedRef = _this.props.forwardedRef;
            if (forwardedRef && forwardedRef.current) {
                _this.setState({
                    lineHeight: getLineHeight(forwardedRef.current)
                });
            }
        };
        _this.onChange = function (e) {
            var onChange = _this.props.onChange;
            _this.currentValue = e.currentTarget.value;
            onChange && onChange(e);
        };
        _this.getLocals = function () {
            var _a = _this, _b = _a.props, onResize = _b.onResize, maxRows = _b.maxRows, onChange = _b.onChange, style = _b.style, props = __rest(_b, ["onResize", "maxRows", "onChange", "style"]), lineHeight = _a.state.lineHeight;
            var maxHeight = maxRows && lineHeight ? lineHeight * maxRows : null;
            return __assign({}, props, { style: maxHeight ? __assign({}, style, { maxHeight: maxHeight }) : style, onChange: _this.onChange });
        };
        return _this;
    }
    TextareaAutosizeInner.prototype.componentDidMount = function () {
        var _a = this.props, maxRows = _a.maxRows, async = _a.async, forwardedRef = _a.forwardedRef;
        if (typeof maxRows === "number") {
            this.updateLineHeight();
        }
        if (typeof maxRows === "number" || async) {
            /*
              the defer is needed to:
                - force "autosize" to activate the scrollbar when this.props.maxRows is passed
                - support StyledComponents (see #71)
            */
            setTimeout(function () {
                return forwardedRef && forwardedRef.current && autosize(forwardedRef.current);
            });
        }
        else {
            forwardedRef && forwardedRef.current && autosize(forwardedRef.current);
        }
        if (forwardedRef && forwardedRef.current) {
            forwardedRef.current.addEventListener(RESIZED, this.onResize);
        }
    };
    TextareaAutosizeInner.prototype.componentWillUnmount = function () {
        var forwardedRef = this.props.forwardedRef;
        if (forwardedRef && forwardedRef.current) {
            forwardedRef.current.removeEventListener(RESIZED, this.onResize);
            autosize.destroy(forwardedRef.current);
        }
    };
    TextareaAutosizeInner.prototype.render = function () {
        var _a = this.getLocals(), children = _a.children, forwardedRef = _a.forwardedRef, locals = __rest(_a, ["children", "forwardedRef"]);
        return (React.createElement("textarea", __assign({}, locals, { ref: forwardedRef }), children));
    };
    TextareaAutosizeInner.prototype.componentDidUpdate = function () {
        var forwardedRef = this.props.forwardedRef;
        forwardedRef &&
            forwardedRef.current &&
            autosize.update(forwardedRef.current);
    };
    TextareaAutosizeInner.defaultProps = {
        rows: 1,
        async: false
    };
    TextareaAutosizeInner.propTypes = {
        rows: PropTypes.number,
        maxRows: PropTypes.number,
        onResize: PropTypes.func,
        forwardedRef: PropTypes.shape({
            current: PropTypes.instanceOf(HTMLElement)
        }),
        async: PropTypes.bool
    };
    return TextareaAutosizeInner;
}(React.Component));
exports.TextareaAutosize = React.forwardRef(function (props, ref) { return React.createElement(TextareaAutosizeInner, __assign({}, props, { forwardedRef: ref })); });
